unit vbxe;

(*
	$0000	XDLIST
	$00E0	CLR_BLIST
	$0100	BLITTER_CODE_BLOCK
	$1000	COLOR_MAP
	$5000	VBXE_OVRADR
*)

{

BlitterBusy
ColorMapOff
ColorMapOn
ClrVideoBank
DstBCB
GetXDL
IniBCB
MoveVideoPage
OverlayOff
RunBCB
SetHorizontalRes
SetVideoBank
SetXDL
SrcBCB
VBXEOff

}

interface

type	TUInt24 =
	record
		byte0: byte;
		byte1: byte;
		byte2: byte;
	end;

	TXDL =
	record
		xdlc_: word;		// blank
		rptl_: byte;

		xdlc: word;
		rptl: byte;
		ov_adr: TUInt24;
		ov_step: word;
		mp_adr: TUInt24;
		mp_step: word;
		mp_hscrol: byte;
		mp_vscrol: byte;
		mp_width: byte;
		mp_height: byte;
		ov_width: byte;
		ov_prior: byte;
	end;

	TBCB =
	record
		src_adr: TUInt24;
		src_step_y: smallint;
		src_step_x: shortint;
		dst_adr: TUInt24;
		dst_step_y: smallint;
		dst_step_x: shortint;
		blt_width: word;
		blt_height: byte;
		blt_and_mask: byte;
		blt_xor_mask: byte;
		blt_collision_mask: byte;
		blt_zoom: byte;
		pattern_feature: byte;
		blt_control: byte;
	end;

const
	LoRes = 1;
	MedRes = 2;
	HiRes = 3;

implementation


procedure SetVideoBank(b: byte); assembler;
asm
{	fxs FX_MEMS b
};
end;


procedure OverlayOff; assembler;
asm
{	@setxdl #e@xdl.ovroff
};
end;


procedure ColorMapOn; assembler;
asm
{	@setxdl #e@xdl.mapon
};
end;

procedure ColorMapOff; assembler;
asm
{	@setxdl #e@xdl.mapoff
};
end;


procedure SetHorizontalRes(a: byte); assembler;
asm
{	@setxdl a
};
end;

procedure SetHRes(a: byte); assembler;
asm
{	@setxdl a
};
end;


procedure MoveVideoPage(src: pointer; dst: cardinal);
var p: pointer;
begin

 SetVideoBank($80+dst shr 12);

 p:=pointer(VBXE_WINDOW+dst mod $1000);

 move(src, p, 256); 

 SetVideoBank(0);

end;


procedure ClrVideoBank(a, i: byte);
var adr: cardinal;
begin
	adr:=(a and $7f) shl 12;
asm
{	txa:pha

	mva adr _adr
	mva adr+1 _adr+1
	mva adr+2 _adr+2

	fxs FX_MEMS #$80+MAIN.SYSTEM.VBXE_XDLADR/$1000

	ldx i
	beq skp
	
loop	ldy #20
	mva:rpl bltClr,y MAIN.SYSTEM.VBXE_WINDOW+$e0,y-

	fxs FX_BL_ADR0 #$e0
	fxs FX_BL_ADR1 #$00
	fxsa FX_BL_ADR2

	fxs FX_BLITTER_START #$01		; !!! start gdy 1 !!!

wait	fxla FX_BLITTER_BUSY
	bne wait

	lda _adr
	add <$1000
	sta _adr
	lda _adr+1
	adc >$1000
	sta _adr+1
	lda _adr+2
	adc #0
	sta _adr+2

	dex
	bne loop

skp	fxs FX_MEMS #$00

	jmp stop

bltClr	.long 0x00	; source address
	.word 0x00	; source step y
	.byte 0x00	; source step x
_adr	.long 0x00	; destination address
	.word 0x0100	; destination step y
	.byte 0x01	; destination step x
	.word 0xff	; width
	.byte 0x0f	; height
	dta 0x00	; and mask (and mask equal to 0, memory will be filled with xor mask)
	dta 0x00	; xor mask
	dta 0x00	; collision and mask
	dta 0x00	; zoom
	dta 0x00	; pattern feature
	dta 0x00	; control

stop	pla:tax
};
end;


procedure IniBCB(var a: TBCB; src,dst: cardinal; w0, w1: smallint; w: word; h: byte; ctrl: byte);
begin
 fillbyte(a, sizeof(a), 0);

 a.src_adr.byte2:=src shr 16;
 a.src_adr.byte1:=src shr 8;
 a.src_adr.byte0:=src;

 a.dst_adr.byte2:=dst shr 16;
 a.dst_adr.byte1:=dst shr 8;
 a.dst_adr.byte0:=dst;

 a.src_step_x:=1;
 a.src_step_y:=w0;

 a.dst_step_x:=1;
 a.dst_step_y:=w1;

 a.blt_width:=w;
 a.blt_height:=h;

 a.blt_and_mask := $ff;

 a.blt_control:=ctrl; 
end;


procedure SrcBCB(var a: TBCB; src: cardinal);
begin

 a.src_adr.byte2 := src shr 16;
 a.src_adr.byte1 := src shr 8;
 a.src_adr.byte0 := src;

end;


procedure DstBCB(var a: TBCB; dst: cardinal);
begin

 a.dst_adr.byte2 := dst shr 16;
 a.dst_adr.byte1 := dst shr 8;
 a.dst_adr.byte0 := dst;

end;


function BlitterBusy: Boolean; assembler;
asm
{	ldy #FX_BLITTER_BUSY
	lda (fxptr),y
	sta Result
};
end;


procedure RunBCB(var a: TBCB); assembler;
asm
{	fxs	FX_BL_ADR0	a
	lda	a+1
	and	#$0f
	fxsa	FX_BL_ADR1
	fxs	FX_BL_ADR2	#$00

	fxs	FX_BLITTER_START #$01		; !!! start gdy 1 !!!

;wait	fxla	FX_BLITTER_BUSY
;	bne	wait
}; 
end;


procedure GetXDL(var a: txdl); register; assembler;
asm
{	fxs FX_MEMS #$80+MAIN.SYSTEM.VBXE_XDLADR/$1000

	ldy #.sizeof(s@xdl)-1

lp	lda MAIN.SYSTEM.VBXE_XDLADR+MAIN.SYSTEM.VBXE_WINDOW,y
	sta (a),y
	dey
	bpl lp

	fxs FX_MEMS #0
};
end;


procedure SetXDL(var a: txdl); register; assembler;
asm
{	fxs FX_MEMS #$80+MAIN.SYSTEM.VBXE_XDLADR/$1000

	ldy #.sizeof(s@xdl)-1

lp	lda (a),y
	sta MAIN.SYSTEM.VBXE_XDLADR+MAIN.SYSTEM.VBXE_WINDOW,y
	dey
	bpl lp

	fxs FX_MEMS #0
};
end;


procedure VBXEOff; assembler;
asm
{	stx FX_CORE_RESET

	fxs FX_MEMC #0
	fxsa FX_MEMS
	fxsa FX_VIDEO_CONTROL
};
end;


end.

